c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
c
c     BALANC.CMD
c
c-----ATDM v1.00
c
c     Used for keeping track of mass fluxes in and out of the modeled region
c
c-----95/02/22:
c     -from UAM-V Revision 1.2  94/02/10  21:03:35  tcm
c     -removed PiG-related mass flux variables
c
c     fluxes are calculated during each hour for the coarse grid 
c     and for each fine (nested) grid.  separate cumulative 
c     fluxes are retained also.  in the following list of 
c     variables, the first is the coarse grid variable, the 
c     second is the cumulative coarse grid variable, the third 
c     is the fine grid variable, and the fourth is the cumulative
c     fine grid variable.
c
c     bcflow, bcflcu, fbcflo, fbcflc -- fluxes across lateral 
c       boundaries.  separate totals are kept for in and out
c       and for each of the four boundaries.
c
c     xbcflo, xtpflo, xbcflc, xtpflc -- fluxes across lateral 
c       boundaries of each fine grid calculated from coarse 
c       grid variables
c
c     tpflow, tpflcu, ftpflo, ftpflc -- fluxes across the top
c       boundary.  separate totals are kept for in and out.
c
c     ptflow, ptflcu, fptflo, fptflc -- flux of emissions
c       from elevated sources.
c
c     eflow, eflcu, feflo, feflc -- flux of area source emissions.
c
c     dpflow, dpflcu, fdpflo, fdpflc -- deposition flux
c
c     tmas, ftmas -- total mass in the coarse grid or a fine
c       grid at the current time.
c
c     xtmas -- total mass in a fine grid calculated from
c       coarse grid variables.
c
      common /balanc/ bcflow(mxspec,2,4), tpflow(mxspec,2), 
     &            ptflow(mxspec), eflow(mxspec), dpflow(mxspec),
     &            bcflcu(mxspec,2,4), tpflcu(mxspec,2), 
     &            ptflcu(mxspec), eflcu(mxspec), dpflcu(mxspec),
     &            tmas(mxspec),
     &            fbcflo(mxspec,2,4,maxfin), ftpflo(mxspec,2,maxfin), 
     &            xbcflo(mxspec,2,4,maxfin), xtpflo(mxspec,2,maxfin), 
     &            fptflo(mxspec,maxfin), feflo(mxspec,maxfin),
     &            fdpflo(mxspec,maxfin),
     &            fbcflc(mxspec,2,4,maxfin), ftpflc(mxspec,2,maxfin), 
     &            xbcflc(mxspec,2,4,maxfin), xtpflc(mxspec,2,maxfin), 
     &            fptflc(mxspec,maxfin), feflc(mxspec,maxfin),
     &            fdpflc(mxspec,maxfin),
     &            ftmas(mxspec,maxfin), xtmas(mxspec,maxfin)
c
