c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
c
c     COMCHEM.CMD
c
c-----ATDM v1.00
c
c     Common decks for ATDM chemistry
c
c-----95/03/06:
c     -from UAM-V Revision 1.2  94/02/10  21:03:47  tcm
c     -major modifications specific to ATDM chemical species
c     -added mxgas, npart, ngas
c-----96/09/11:dfg
c     -added more gas species in common chdata for Micro CB4 mechanism.
c     -added lreac,lssic,lssbc to common chpar1.
c     -added common chpar2 and chpar3 for use of Micro CB4 mechanism.
c     -changed mxgas in common chdata2 to mxgas1. (These parameters
c      only for simple parameterized chemistry).
c     -added common chrad
c     -added lso2, lntr, lsulf, lss
c-----98/03/06:dfg
c     -add isop to common CHDATA
c
c     /chdata/ contains species indices, names, and coefficients
c     required by ATDM 
c
      character*4 mspec,mspm,mspint
      common /chpar1/mspec(10,mxspec),lreac(mxspec),lssic(mxspec),
     &     lssbc(mxspec),bdnl (mxspec)
c
      common /chpar2/rkn(mxgrx),rk(mxgrx),lphot(mxgrx),ltdep(mxgrx),
     &  acten(mxgrx), rkn3(mxgrx), acten3(mxgrx), lpdep(mxgrx),
     &  norder(mxgrx)
c
      common /chpar3/kt(naqeq),aqrk1(naqeq),aqrk2(naqeq),
     &  k0(naqeq),dhor(naqeq),kaq1(naqeq),kaq2(naqeq),
     &  tkaq1(naqeq),tkaq2(naqeq),ldark,lmap(mxgas)
c
      common /chdata/ kNO, kNO2S, kO3, kNO2,
     &                kCARB, kVOC, kPNA, kPAN, kCO,  kHNO2, kH2O2, 
     &                kHNO3, kNTR, kSO2, kSULF,kISOP, kTERP, kSV1,
     &                kSV2,  kSV3, kSV4,  kNH3,
     &                knaph,   kpom1,   kpom2,   khg0(mxhg),
     &                khg2(mxhg),   kdiox,   katraz,
     &                kpno3,   kgso4,   kaso4,   knh4n,   knh4s,
     &                ksoc,    kpoc,    ksoa1, ksoa2, ksoa3, ksoa4,
     &                kpec,    kpfin,   kpcrs,
     &                khgp(mxhg), kcd(mxcd), kpom1p,  kpom2p,  kdioxp,
     &                katrazp
      common /chrads/ kO1D, kO, kNO3, kN2O5, kHO2, kOH, kC2O3,
     &                kXO2, kXO2N, kROR

      common /chrad/  O1D, O, NO3, N2O5, HO2, OH, C2O3, 
     &                XO2, XO2N, ROR,
     &                lss,    lso2 , lntr  , lsulf
      common /chdata2/ nspint,ngas,npart,nspm,jind(mxspec),
     &                 mspint(10,mxspec),mspm(10,mxspec),
     &                 dratio(0:mxgas),freact(0:mxgas),
     &                 molwt(mxspec),ekh0(0:mxgas),ek1d0(0:mxgas),
     &                 ek2d0(0:mxgas),tdep(0:mxgas),
     &                 tdep1d(0:mxgas),tdep2d(0:mxgas),heffso
      common /ppmcon/ cpfac
c
      dimension kind(mxspec), krads(mxrads)
      equivalence (kind(1),kno), (krads(1),kO1D)
      real no3, n2o5
      logical lreac,lssic,lssbc,lphot,ltdep,ldark,lpdep
      logical lss, lso2, lntr, lsulf
      real kt,k0,kaq1,kaq2
      real molwt

c
