c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine eftot(nxf,nyf,nfspec,qfarea,ifine,idebug)
c
c-----ATDM v1.00
c
c     Sums sources for a fine grid and write totals
c
c-----95/03/31:
c     -from UAM-V Revision 1.2  94/02/10 20:54:59  tcm
c     -modifications made following UAM-V to correct vertical nesting code
c-----95/09/25:
c     -improved format of fine grid totals to diag file
c
c     Input arguments
c               nxf:            number of fine grid cells in x-direction    
c               nyf:            number of fine grid cells in y-direction
c               nfspec:         number of modeled species
c               qfarea:         fine grid area emission rates (mol/min)
c               ifine:          fine grid index
c               idebug:         diagnostic debug flag
c     Files written:
c               8:              diagnostic file
c     Called by:
c               atdm      setup 
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'efcon.cmd'
      dimension qfarea(nxf,nyf,nfspec)
c
      do 50 ll=1,nfemit(ifine)
        l=kfemit(ll,ifine)
        if ( l .le. 0 ) goto 50
        tfarea(l,ifine)=0.0
        do 40 j=1,nyf
          do 30 i=1,nxf
             tfarea(l,ifine)=tfarea(l,ifine)+qfarea(i,j,ll)
   30     continue
   40   continue
   50 continue
      write(8,'(a,i5)') 'Emission totals for fine grid ',ifine
      write(8,3900) (tfarea(i,ifine),i=1,nfspec)
 3900 format(' TFAREA= ',/,10(1pe12.4))
      return
      end
