c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
c
      SUBROUTINE FASTRATE (NOSPEC,HH,HR,RATE)
      INCLUDE  'parchm.cmd'
      INCLUDE  'comchem.cmd'
      INCLUDE  'comchem2.cmd'
      DIMENSION  RATE(nors), HH(nors), HR(MXRADS)
c*************************************************
c     INPUT OF CONCENTRATION DATA -- PPM UNIT
c*************************************************
      SO2  = 0.
      SULF = 0.
      NO = HH(KNO)
      NO2S = HH(KNO2S)
      O3 = HH(KO3)
      NO2 = HH(KNO2)
      CARB = HH(KCARB)
      VOC = HH(KVOC)
      PNA = HH(KPNA)
      PAN = HH(KPAN)
      CO = HH(KCO)
      HNO2 = HH(KHNO2)
      H2O2 = HH(KH2O2)
      HNO3 = HH(KHNO3)
      IF (LNTR) NTR = HH(KNTR)
      IF (LSO2) SO2 = HH(KSO2)
      IF (LSO2) SULF = HH(KSULF)
      ISOP = HH(KISOP)
      TERP = HH(KTERP)
      SV1 = HH(KSV1)
      SV2 = HH(KSV2)
      SV3 = HH(KSV3)
      SV4 = HH(KSV4)
      O1D = HR(KO1D)
      O = HR(KO)
      NO3 = HR(KNO3)
      N2O5 = HR(KN2O5)
      HO2 = HR(KHO2)
      OH = HR(KOH)
      C2O3 = HR(KC2O3)
      XO2 = HR(KXO2)
      XO2N = HR(KXO2N)
      ROR = HR(KROR)
c
c     *** zero out rate for state species. 
c 
       do 100 i=1,nospec
          rate(i) = 0. 
 100   continue
c
c      Calculating the rate for state species
c
      Sink =   - rk(3)*O3  - rk(6)*O  - rk(17)*NO3
     &   - rk(25)*NO  - rk(25)*NO  - rk(26)*NO2S*H2O
     &   - rk(27)*OH  - rk(37)*HO2  - rk(38)*XO2
     &   - rk(39)*XO2N  - rk(51)*C2O3
      Source = 1.*rk(1)*NO2S +1.*rk(4)*O*NO2S
     &  +.11*rk(16)*NO3 +1.*rk(18)*NO3*NO2S
     &  +1.*rk(28)*HNO2 +1.*rk(30)*HNO2*HNO2
     &  +.2*rk(73)*ISOP*NO2S
      Rate(kNO) = Source + Sink*NO
      Sink =   - rk(1)  - rk(4)*O  - rk(5)*O
     &   - rk(7)*O3  - rk(18)*NO3  - rk(19)*NO3
     &   - rk(26)*NO*H2O  - rk(31)*OH  - rk(32)*HO2
     &   - rk(52)*C2O3  - rk(61)*ROR  - rk(73)*ISOP
      Source = 1.*rk(3)*O3*NO +1.*rk(6)*O*NO
     &  +.89*rk(16)*NO3 +2.*rk(17)*NO3*NO
     &  +1.*rk(18)*NO3*NO2S +2.*rk(20)*NO3*NO3
     &  +1.*rk(21)*NO3*OH +1.*rk(24)*N2O5
     &  +2.*rk(25)*NO*NO +1.*rk(29)*OH*HNO2
     &  +1.*rk(30)*HNO2*HNO2 +1.*rk(33)*PNA
     &  +.61*rk(35)*PNA +1.*rk(37)*HO2*NO
     &  +1.*rk(38)*XO2*NO +1.*rk(51)*C2O3*NO
     &  +1.*rk(53)*PAN +1.*rk(63)*VOC*NO3
     &  +.2*rk(72)*ISOP*NO3 +.474*rk(77)*TERP*NO3
      Rate(kNO2S) = Source + Sink*NO2S
      Sink =   - rk(3)*NO  - rk(7)*NO2S  - rk(8)
     &   - rk(9)  - rk(12)*OH  - rk(13)*HO2
     &   - rk(62)*VOC  - rk(71)*ISOP  - rk(76)*TERP
      Source = 1.*rk(2)*O
      Rate(kO3) = Source + Sink*O3
      Sink = 0.
      Source = -1.*rk(1)*NO2S +1.*rk(3)*O3*NO
     &  +-1.*rk(4)*O*NO2S +1.*rk(6)*O*NO
     &  +-.11*rk(16)*NO3 +1.*rk(17)*NO3*NO
     &  +-1.*rk(18)*NO3*NO2S +-1.*rk(22)*NO3*HO2
     &  +-2.*rk(23)*N2O5*H2O +2.*rk(25)*NO*NO
     &  +-1.*rk(26)*NO*NO2S*H2O +1.*rk(29)*OH*HNO2
     &  +1.*rk(30)*HNO2*HNO2 +-1.*rk(31)*NO2S*OH
     &  +-1.*rk(32)*HO2*NO2S +1.*rk(33)*PNA
     &  +1.*rk(34)*OH*PNA +1.*rk(35)*PNA
     &  +1.*rk(36)*OH*HNO3 +1.*rk(37)*HO2*NO
     &  +1.*rk(38)*XO2*NO +-1.*rk(50)*CARB*NO3
     &  +1.*rk(51)*C2O3*NO +-1.*rk(52)*C2O3*NO2S
     &  +1.*rk(53)*PAN +-1.*rk(61)*ROR*NO2S
     &  +-.8*rk(72)*ISOP*NO3 +-1.*rk(73)*ISOP*NO2S
     &  +-.526*rk(77)*TERP*NO3
      Rate(kNO2) = Source + Sink*NO2
c
      RETURN
      END
