c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine fgdepr(iunit,nxf,nyf,nspd,nfspec,kavspc,dpositf,
     &                  wpositf)
c
c-----ATDM v1.00
c
c     Writes fine-grid deposition fluxes to binary file
c
c-----95/10/26:
c     C Emery  SAI
c     -from FGAVWR
c
c     Input arguments:
c               iunit:          fine grid average file unit number   
c               nxf:            number of fine grid cells in x-direction
c               nyf:            number of fine grid cells in x-direction
c               nspd:           maximum number of species
c               nfspec:         number of averaged species
c               kavspc:         array to map modeled species to averaged species
c               dpositf:        fine grid dry deposition flux (g/km2)
c               wpositf:        fine grid wet deposition flux (g/km2)
c     Files written:
c               iunit:          fine grid average file
c     Called by:
c               printr
c
      dimension kavspc(nspd)
      dimension dpositf(nxf,nyf,nspd),wpositf(nxf,nyf,nspd)
c
      do 100 l=1,nfspec
        linspc = kavspc(l)
        write(iunit) ((dpositf(i,j,linspc),i=1,nxf),j=1,nyf)
        write(iunit) ((wpositf(i,j,linspc),i=1,nxf),j=1,nyf)
  100 continue
      return
      end
