c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine fgwrit(iunit,nxf,nyf,nzf,nfspec,cncf,
     &                  ifohf,ko3,kh2o2,kpec)
c
c-----ATDM v1.00
c
c     Writes out instantaneous fine grid concs to binary file
c
c-----95/06/05:
c     -from UAM-V Revision 1.2  94/02/10  20:55:52  tcm
c
c     Input arguments:
c               iunit:          fine grid instantaneous concentration file unit
c               nxf:            number of fine grid cells in x-direction
c               nyf:            number of fine grid cells in y-direction
c               nzf:            number of fine grid layers
c               nfspec:         number of modeled species
c               cncf:           array of fine grid concentrations (ppm)
c     Files written:
c               iunit:          fine grid instantaneous concentration file
c     Called by:
c               printr    prtint
c
      dimension cncf(nxf,nyf,nfspec,nzf)
c
      do 100 l=1,nfspec
        do 90 k=1,nzf
          write(iunit) ((cncf(i,j,l,k),i=1,nxf),j=1,nyf)
   90   continue
  100 continue
c
c  write ozone in a file with OH if necessary.  dfg, 4/14/99
c
       if (ifohf.gt.0) then
         do k=1,nzf
           write(ifohf) ((cncf(i,j,kh2o2,k),i=1,nxf),j=1,nyf)
         end do
         do k=1,nzf
           write(ifohf) ((cncf(i,j,ko3,k),i=1,nxf),j=1,nyf)
         end do
         do k=1,nzf
           write(ifohf) ((cncf(i,j,kpec,k),i=1,nxf),j=1,nyf)
         end do
       endif
      return
      end
