c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine finfil(concf,pstarf,nxf,nyf,nsp,nzf,ifine)
c
c-----ATDM v1.00
c
c     Fills in fine grid concentrations with coarse grid concentrations.
c     For initial concentrations.
c
c-----95/06/05:
c     -from UAM-V Revision 1.2  94/02/10  20:55:56  tcm
c-----95/06/23:
c     -modified calculation of fine grid concentrations for ppm and sigma
c     -added pstarf to argument list
c
c     Input arguments:
c               pstarf:         array of fine grid P* (mb)
c               nxf:            number of fine grid cells in x-direction     
c               nyf:            number of fine grid celss in y-direction
c               nsp:            number of modeled species
c               nzf:            number of fine grid layers
c               ifine:          fine grid index
c     Output arguments:
c               concf:          array of concentrations (ppm)
c     Called by:
c               atdm 
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      dimension concf(nxf,nyf,nsp,nzf),pstarf(nxf,nyf)
      include 'comuam.cmd'
      include 'deffin.cmd'
c
c  set fine grid for all levels and all species
c
      do 200 k=1,nlayer
        kf2 = kvmap(k,ifine)
        if (k .eq. 1) then
          kf1 = 1
        else
          kf1 = kvmap(k-1,ifine) + 1
        endif
        do 190 n=1,nospec
          do 180 kf=kf1,kf2
            do 150 j=2,nyf-1
              jc = jyfb(ifine) + (j-2)/nhf(ifine)
              do 140 i=2,nxf-1
                ic = ixfb(ifine) + (i-2)/nhf(ifine)
                concf(i,j,n,kf) = conc(ic,jc,n,k)*
     &                            pstar(ic,jc)/pstarf(i,j)
  140         continue
  150       continue
  180     continue
  190   continue
  200 continue
c
      return
      end
