c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine flxnit(nospec,numfin)
c
c-----ATDM v1.00
c
c     Initializes all flux tracking arrays to zero
c
c-----95/06/01:
c     -from UAM-V Revision 1.2  94/02/10  20:56:04  tcm
c
c     Input arguments:
c               nospec:         number of modeled species
c               numfin:         number of fine grids
c     Called by:
c               setup
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'balanc.cmd'
c
c  zero coarse grid cum arrays
c
      do 150 l=1,nospec
        eflcu(l) = 0.
        ptflcu(l) = 0.
        dpflcu(l) = 0.
        do 140 n=1,2
          tpflcu(l,n) = 0.
          do 130 k=1,4
            bcflcu(l,n,k) = 0.
  130     continue
  140   continue
  150 continue
c
c  zero coarse grid hourly arrays
c
      do 230 l=1,nospec
        eflow(l) = 0.
        ptflow(l) = 0.
        dpflow(l) = 0.
        do 220 n=1,2
          tpflow(l,n) = 0.
          do 210 k=1,4
            bcflow(l,n,k) = 0.
  210     continue
  220   continue
  230 continue
c
c  do the following for all fine (nested) grids
c
      do 500 ifine=1,numfin
c
c  zero fine grid cum arrays
c
        do 350 l=1,nospec
          feflc(l,ifine) = 0.
          fptflc(l,ifine) = 0.
          fdpflc(l,ifine) = 0.
          do 340 n=1,2
            ftpflc(l,n,ifine) = 0.
            xtpflc(l,n,ifine) = 0.
            do 330 k=1,4
              fbcflc(l,n,k,ifine) = 0.
              xbcflc(l,n,k,ifine) = 0.
  330       continue
  340     continue
  350   continue
c
c  zero fine grid hourly arrays
c
        do 430 l=1,nospec
          feflo(l,ifine) = 0.
          fptflo(l,ifine) = 0.
          fdpflo(l,ifine) = 0.
          do 420 n=1,2
            ftpflo(l,n,ifine) = 0.
            xtpflo(l,n,ifine) = 0.
            do 410 k=1,4
              fbcflo(l,n,k,ifine) = 0.
              xbcflo(l,n,k,ifine) = 0.
  410       continue
  420     continue
  430   continue
c
  500 continue
c
      return
      end
