c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine gtpstrfs(nxx,nxf,nyf,iedg,zin,zout)
c
c-----ATDM v1.00
c
c     Returns a 1d vector (zout) containing the row of values
c     along boundary iedg in the 2d array zin.
c
c-----95/06/29:
c     G Mansell SAI
c
c     Input arguments:
c               nxx:		number of elements of output vector
c               nxf:            number of fine grid cells in x-direction        
c               nyf:            number of fine grid cells in y-direction        
c               iedg:           iedg of boundary (1=N,2=S,3=E,4=W)
c               zin:            2-D input array
c     Output arguments:
c               zout:           1-D output array
c     Called by:
c               fbdfil
c
      dimension zin(nxf,nyf), zout(nxx)
c
      if ( iedg .eq. 1 ) then
	do 10 i=1,nxf
	  zout(i)=zin(i,nyf)
   10   continue
      elseif ( iedg .eq. 2 ) then
	do 20 i=1,nxf
	  zout(i)=zin(i,1)
   20   continue
      elseif ( iedg .eq. 3 ) then
	do 30 j=1,nyf
	  zout(j)=zin(nxf,j)
   30   continue
      elseif ( iedg .eq. 4 ) then
	do 40 j=1,nyf
	  zout(j)=zin(1,j)
   40   continue
      endif
c
      return
      end
