c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine heddv(nosp)
c
c-----ATDM v1.00
c
c     Reads header of deposition velocity file and
c     fills in species table for main routine
c
c-----95/02/22:
c     -from UAM-V Revision 1.2  94/02/10  20:56:57  tcm
c     -removed code specific to FORM and HONO
c
c     Input arguments:
c               nosp:           number of species carried by model             
c     Files read:
c               idepv:          deposition velocity file
c     Files written:
c               6:              standard output file unit (*)
c     Called by:
c               setup
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'comchem.cmd'
      include 'comuam.cmd'
c
      character*4 memsp(10,mxspec)
      character*10 m1, m2
c
      read(idepv) ndvsp, ((memsp(m,l),m=1,10),l=1,ndvsp)
      IF (ndvsp .gt. mxspec) then
        write(*,*) 'NUMBER OF SPECIES ON DEPOSITION VELOCITY FILE (',
     &             ndvsp,') IS GREATER THAN MAX ALLOWED (',mxspec,').'
        stop
      endif
c
c  find each species on file in standard species list
c  (0 will mean a species on file that is not needed.)
c
      do 100 l=1,ndvsp
        write(m1,'(10a1)') (memsp(i,l),i=1,10)
        do 80 lint=1,nosp
          write(m2,'(10a1)') (mspec(i,lint),i=1,10)
          if (m1 .eq. m2) then
            kdvsp(l) = lint
            write(*,'(a,i3,1x,a,a,i3,1x,a,a)') ' Species ',l,m1,
     &            ' on deposition velocity file = species ',
     &            lint,m2,' internally.'
            go to 100
          endif
   80   continue
        kdvsp(l) = 0
  100 continue
c
      return
      end
