c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine hgtnew(deltat)
c
c-----ATDM v1.00
c
c     For current timestep, updates values of surface pressure, P*, layer
c     pressure, and layer interface heights for ensuing calculations
c
c-----95/06/07:
c     C Emery SAI
c
c     Input parameters:
c               deltat:         coarse grid time step (min)      
c     Called by:
c               atdm
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'comuam.cmd'
      include 'com3.cmd'
      include 'latlon.cmd'
      data eps /0.622/, rd /287./, grav /9.8/
c
      elapsth = elapsth + deltat
      do 100 j = 1,noy
c
c     check if inside of modeling region
c
        if (istr(j).ge.nox) go to 100
        is = istr(j)
        ie = iend(j)
        do 90 i = is,ie
c
c     Update surface pressure from PSOLD and PSNEW
c
          psfc(i,j) = psold(i,j) + elapsth*(psnew(i,j) - psold(i,j))/
     &                datadt
          pstar(i,j) = psfc(i,j) - pmodtop
c
c     Update PRESS and H arrays
c
          do 82 k = 1,nlayer
            prsupr = sigma(k+1)*pstar(i,j) + pmodtop
            prslwr = sigma(k)*pstar(i,j) + pmodtop
            press(i,j,k) = (prsupr + prslwr)/2.
            tvirt = temper(i,j,k)*(eps + ch2o(i,j,k))/
     &              (eps*(1. + ch2o(i,j,k)))
            hbar = rd*tvirt/grav
            if (k.eq.1) then
              h(i,j,k) = hbar*alog(psfc(i,j)/prsupr)
            else
              h(i,j,k) = h(i,j,k-1) + hbar*alog(prslwr/prsupr)
            endif
   82     continue
c
   90   continue
  100 continue
      return
      end
