c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
c
c     PARCHM.CMD
c
c-----ATDM v1.00
c
c     Parameters for ATDM chemistry
c
c-----95/04/03:
c     -from UAM-V Revision 1.2  94/02/10  21:04:52  tcm
c     -added mxsdist (max number of input size distributions) and
c      nbin (max number of input size bins)
c-----95/06/20:
c     -removed mxgrx, mxarx, mxeql, mxpspc, mxxspc
c-----95/06/28:
c     -added parameter mxspec4
c     -increased mxspec from 16 to 25
c-----95/07/21:
c     -added mxgas parameter
c     -removed mxspec4
c     -increased mxspec from 25 to 29
c-----95/08/15:
c     -added parameters specific to OH lookup tables
c-----96/09/11:
c     -increased mxspec from 29 to 38.
c     -increased mxgas from 13 to 22.
c     -set mxgas1=13 for simple parameterized chemistry.
c     -added parameter mxgrx, naqeq.
c     -added parameters nors (number of reactive species in Micro CB4).
c-----98/03/06:
c     -increased mxspec from 38 to 40.
c     -increased mxgas from 22 to 23.
c     -increased nors from 14 to 15.
c     -increased mxgrx from 60 to 65.
c-----99/03/22:
c     -added a parameter mxrad=10 (for micro cb4)
c
      parameter (mxhg=24)
      parameter (mxcd=10)
      parameter (mxspec=46+3*mxhg+mxcd)
      parameter (mxgas=27+2*mxhg)
      parameter (nors=21)
      parameter (mxrads=10)
      parameter (mxgas1=13)
      parameter (mxgrx=77)
      parameter (naqeq=32)
      parameter (nhen=32)
      parameter (nbin=8)
      parameter (mxsdist=9)
      parameter (nmo3p=6,nmz=5,nmt=6,nmh2o=7,nmo3=8,nmnox=13,nmvoc=7)
      parameter (n1=nmvoc,n2=nmnox*n1,n3=nmo3*n2,n4=nmh2o*n3)
      parameter (n5=nmt*n4,nzo3p=16,nmoh=nzo3p*n5)
      parameter (wtair=28.97, wth2o=18.0)
c
