c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine pfage(nxf,nyf,psnewf,psoldf,psfcf)
c
c-----ATDM v1.00
c
c     Replaces old fine grid surface pressures with new surface pressures in 
c     preparation for reading in new data
c
c-----95/06/02:
c     C Emery SAI
c
c     Input arguments:
c               nxf:            number of fine grid cells in x-direction   
c               nyf:            number of fine grid cells in y-direction
c               nzf:            number of layers
c               psnewf:         array of new surface pressures (mb)
c     Output arguments:
c               psoldf:         array of old surface pressures (mb)
c               psfcf:          array of current surface pressures (mb)
c     Called by:
c               update
c
      dimension psfcf(nxf,nyf), psoldf(nxf,nyf), psnewf(nxf,nyf)
c
      do 90 j=1,nyf
        do 80 i=1,nxf
          psfcf(i,j) = psnewf(i,j)
          psoldf(i,j) = psnewf(i,j)
   80   continue
   90 continue
      return
      end
