c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
c***************************************************************
      subroutine xfine1(time,ndate,deltat,mavg,datafl,idebug)
c
      include 'parfin.cmd'
      include 'parchm.cmd'
      include 'parm.cmd'
      include 'comuam.cmd'
      include 'aerosl.cmd'
      include 'ctlflg.cmd'
      include 'com3.cmd'
      include 'deffin.cmd'
      include 'shrfin.cmd'
      include 'com1f.cmd'
      include 'efcon.cmd'
      include 'balanc.cmd'
      include 'iemcon.cmd'
      include 'stack.cmd'
c
      dimension tarray(2)
      dimension elapg(maxfin)
      dimension crsfltm(maxfin),tstptm(maxfin),verttm(maxfin)
      dimension vrtdtm(maxfin),stpxtm(maxfin),stpztm(maxfin)
      dimension difftm(maxfin),rchmtm(maxfin)
      logical lfdone,datafl
c
      data nmxpas /1000/
      data maxpas /15/
      data idiagt /0/
c
c      write(*,*) ' Enter xfine1...time,deltat,mavg,datafl,numfin:',
c     &                            time,deltat,mavg,datafl,numfin
c
      idiag=and(idebug,1)
c
c     FINE GRID SECTION  (will be bypassed if numfin is 0)
c
      crsfltmt=0.0
      tstptmt=0.0
      verttmt=0.0
      vrtdtmt=0.0
      stpxtmt=0.0
      stpztmt=0.0
      difftmt=0.0
      rchmtmt=0.0
c
      do 320 ifine=1,numfin
        elapg(ifine) = 0.
        crsfltm(ifine)=0.0
        tstptm(ifine)=0.0
        verttm(ifine)=0.0
        vrtdtm(ifine)=0.0
        stpxtm(ifine)=0.0
        stpztm(ifine)=0.0
        difftm(ifine)=0.0
        rchmtm(ifine)=0.0
  320 continue
c
c-----Determine fine grid timestep parameters
c
       if ( datafl ) then
        if (numfin .gt. 0) then
          call fstep(deltat,idebug)
          if (idiag .ne. 0 .or. idiagt .ne. 0) then
            ifine = numfin
            write(*,'(a,/,a,/,4i4,2f10.2,f10.4,f10.4,i4)')
     &           ' Coming out of fstep: ifine,nfx,nfy,nfz,',
     &           ' delfx(1),delfy,deltat,deltf,ndtf', ifine, nfx(ifine),
     &           nfy(ifine), nfz(ifine), delfx(1,ifine), delfy(ifine),
     &           deltat, deltf(ifine), ndftot(ifine)
          endif
        endif
	datafl=.false.
       else
	 do if=1,numfin
	   ndftot(if)=ndftots(if)
	   ndfmax(if)=ndfmaxs(if)
	   ndfcom(if)=ndfcoms(if)
	 enddo
       endif
c
c-----Do several passes over fine grids
c
      dummy=dtime(tarray)
      do 450 ifpass=1,nmxpas
        ifpout = ifpass
c
	if ( idiagt .ne. 0 ) write(*,*) ' ifpass :',ifpass
c
c-----Set up which grids will be done on this pass and see if
c     all have by any chance been completed.
c
        lfdone = .true.
        do 355 ifine=1,numfin
c           write (*,*) 'loop 355', ifine
c
c         if all steps are not done for this grid, then we
c         are not done with a coarse grid step.
c
	if ( idiagt .ne. 0 ) then
	   write(*,*) ' ifine :',ifine
	   write(*,*) 'ndfcom,ndftot :',ndfcom(ifine),ndftot(ifine)
        endif
c
          if (ndfcom(ifine) .lt. ndftot(ifine)) then
            lfdone = .false.
c
c           if this grid is inside another, don't let the outer
c           grid get ahead of this one by more than one step.
c
            if (ifgptr(ifine) .gt. 0) then
              if (ndfcom(ifgptr(ifine))*deltf(ifgptr(ifine))
     &          .gt. ndfcom(ifine)*deltf(ifine)+.00001) then
                ndfmax(ifgptr(ifine)) = 0
              else
c
c               unless the next grid out is done with a coarse
c               grid step, it can take another step.
c
                if (ndfcom(ifgptr(ifine)) .lt. ndftot(ifgptr(ifine)))
     &                ndfmax(ifgptr(ifine)) = 1
              endif
            endif
c
c         on the other hand, if all steps are done for this
c         grid, make sure no extra steps are taken
c 
          else
            ndfmax(ifine) = 0
          endif
  355   continue
        if (lfdone) go to 460
c
c-----Loop over all fine grids
c
        do 400 ifine=1,numfin
c           write (*,*) 'loop 400', ifine, numfin
c
	if ( idiagt .ne. 0 ) then
	   write(*,*) ' ifine :',ifine,' ndfmax :',ndfmax(ifine)
        endif
c
          if (ndfmax(ifine) .eq. 0) go to 400
          dummy=dtime(tarray)
          cpuf1=tarray(1)
c
c-----Calculate fkh (horizontal diffusivities on fine grid)
c
          call diffsf(nfx(ifine),nfy(ifine),nfz(ifine),
     &                delfx(1,ifine),delfy(ifine),uf(1,1,ifine),
     &                vf(1,1,ifine),fkh)
          dummy=dtime(tarray)
          difftm(ifine)=difftm(ifine)+tarray(1)
c
c-----Loop over fine grid steps to complete one coarse grid step
c
          mfav = 2
          do 390 nfstep=1,ndfmax(ifine)
            dummy=dtime(tarray)
            ndfcom(ifine) = ndfcom(ifine) + 1
            timfg = time + (ndfcom(ifine)-1)*deltf(ifine)/2.
            timfg_ch = time + (ndfcom(ifine)-1)*deltf(ifine)

            deltht = elapsth - deltat + ndfcom(ifine)*deltf(ifine)
	    do 391 if2=1,numfin
c
               call htfnew(nfx(if2),nfy(if2),nfz(if2),deltht,pmodtop,
     &                     sigmaf(1,if2),psoldf(1,if2),psnewf(1,if2),
     &                     temprf(1,1,if2),ch2of(1,1,if2),psfcf(1,if2),
     &                     pstarf(1,if2),presf(1,1,if2),htf(1,1,if2))
  391       continue
c
	if ( idiagt .ne. 0 ) then
	   write(*,*) ' nfstep, ndfcom :'
	   write(*,*)  nfstep, ndfcom(ifine)
	   write(*,*) ' deltf,timfg,timfg_ch :'
	   write(*,*) deltf(ifine),timfg,timfg_ch
        endif
c
c-----Calculate vertical wind component
c
            call fvrtwd(nfx(ifine),nfy(ifine),nfz(ifine),
     &                  psnewf(1,ifine),psoldf(1,ifine),
     &                  pstarf(1,ifine),uf(1,1,ifine),
     &                  vf(1,1,ifine),sigdotf(1,1,ifine),ifine)
            if (idiag .ne. 0) then
              write(*,'(a,i3)') ' finished fvrtwd, ifine = ', ifine
              call fmscal(nfx(ifine),nfy(ifine),nfz(ifine),
     &                    delfx(1,ifine),delfy(ifine),sigmaf(1,ifine),
     &                    pstarf(1,ifine),cncf(1,1,1,ifine),ifine)
              write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &               (ftmas(l,ifine),l=1,nospec)
            endif
c
c-----Inject point source and area emissions into fine grid
c
            call emfine(nfx(ifine),nfy(ifine),nfz(ifine),nfemit(ifine),
     &           nospec,delfx(1,ifine),delfy(ifine),sigmaf(1,ifine),
     &                  qfarea(1,1,ifine),htf(1,1,ifine),
     &                  pstarf(1,ifine),cncf(1,1,1,ifine),
     &                  ifine,idebug)
            if (idiag .ne. 0) then
              write(*,'(a)') ' finished emfine'
              call fmscal(nfx(ifine),nfy(ifine),nfz(ifine),
     &                    delfx(1,ifine),delfy(ifine),sigmaf(1,ifine),
     &                    pstarf(1,ifine),cncf(1,1,1,ifine),ifine)
              write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &               (ftmas(l,ifine),l=1,nospec)
            endif
c
c-----Do mass budget calculations
c
            call fmsflo(nfx(ifine),nfy(ifine),nfz(ifine),
     &                  delfx(1,ifine),delfy(ifine),sigmaf(1,ifine),
     &                  cncf(1,1,1,ifine),uf(1,1,ifine),vf(1,1,ifine),
     &                  pstarf(1,ifine),bcf,deltf(ifine),ifine)
c
c-----Check if any fine grids within this one; fill in bc's if so
c
            call fbdfil(ifine,nfx(ifine),nfy(ifine),nfz(ifine),
     &                  nospec,pstarf(1,ifine),cncf(1,1,1,ifine))
            dummy=dtime(tarray)
            verttm(ifine)=verttm(ifine)+tarray(1)
c
c-----Perform vertical diffusion
c
            call fvrtdif(nfx(ifine),nfy(ifine),nfz(ifine),nospec,
     &                   deltf(ifine)/2.,ifine,pstarf(1,ifine),
     &                   presf(1,1,ifine),temprf(1,1,ifine),
     &                   ch2of(1,1,ifine),fkv(1,1,ifine),htf(1,1,ifine),
     &                   depvelf(1,1,ifine),cncf(1,1,1,ifine),
     &                   dpositf(1,1,ifine),idebug)
            if (idiag .ne. 0) then
              write(*,'(a)') ' finished clvdff'
              call fmscal(nfx(ifine),nfy(ifine),nfz(ifine),
     &                    delfx(1,ifine),delfy(ifine),sigmaf(1,ifine),
     &                    pstarf(1,ifine),cncf(1,1,1,ifine),ifine)
              write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &               (ftmas(l,ifine),l=1,nospec)
            endif
            dummy=dtime(tarray)
            vrtdtm(ifine)=vrtdtm(ifine)+tarray(1)
c
c-----Perform vertical advection
c
            call stepzf(nfx(ifine),nfy(ifine),nfz(ifine),nospec,
     &                  deltf(ifine)/2.,sigdotf(1,1,ifine),
     &                  htf(1,1,ifine),vgf(1,1,1,ifine),
     &                  cncf(1,1,1,ifine),idebug,ifine)
            if (idiag .ne. 0) then
              write(*,'(a)') ' finished stepzf'
              call fmscal(nfx(ifine),nfy(ifine),nfz(ifine),
     &                    delfx(1,ifine),delfy(ifine),sigmaf(1,ifine),
     &                    pstarf(1,ifine),cncf(1,1,1,ifine),ifine)
              write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &               (ftmas(l,ifine),l=1,nospec)
            endif
            dummy=dtime(tarray)
	    stpztm(ifine)=stpztm(ifine)+tarray(1)
c
c-----Perform horizontal advection
c
            call stepxf_04(nfx(ifine),nfy(ifine),nfz(ifine),nospec,
     &                   pstarf(1,ifine),psoldf(1,ifine),
     &                   psnewf(1,ifine),fkh,uf(1,1,ifine),
     &                   vf(1,1,ifine),bcf(1,1,1,1,ifine),
     &                   cncf(1,1,1,ifine),temprf(1,1,ifine),
     &                   ch2of(1,1,ifine),psfcf(1,ifine),
     &                   presf(1,1,ifine),htf(1,1,ifine),
     &                   deltf(ifine)/2.,deltht,ifine)
c
            call stepyf_04(nfx(ifine),nfy(ifine),nfz(ifine),nospec,
     &                   pstarf(1,ifine),psoldf(1,ifine),
     &                   psnewf(1,ifine),fkh,uf(1,1,ifine),
     &                   vf(1,1,ifine),bcf(1,1,1,1,ifine),
     &                   cncf(1,1,1,ifine),temprf(1,1,ifine),
     &                   ch2of(1,1,ifine),psfcf(1,ifine),
     &                   presf(1,1,ifine),htf(1,1,ifine),
     &                   deltf(ifine)/2.,deltht,ifine)
c
            if (idiag .ne. 0) then
              write(*,'(a)') ' finished stepxyf'
              call fmscal(nfx(ifine),nfy(ifine),nfz(ifine),
     &                    delfx(1,ifine),delfy(ifine),sigmaf(1,ifine),
     &                    pstarf(1,ifine),cncf(1,1,1,ifine),ifine)
              write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &               (ftmas(l,ifine),l=1,nospec)
            endif
            dummy=dtime(tarray)
	    stpxtm(ifine)=stpxtm(ifine)+tarray(1)
c
c-----Perform chemistry on fine grid 
c
            if (lpmchm .or. ltxchm) then
	      dummy=dtime(tarray)
	      if ( lmech ) then
                call rchem2f(timfg_ch,ndate,deltf(ifine),idebug,
     &                    nfx(ifine),nfy(ifine),nfz(ifine),nospec,ifine,
     &                    rainf(1,ifine),htf(1,1,ifine),
     &                    presf(1,1,ifine),temprf(1,1,ifine),
     &                    clh2of(1,1,ifine), rnh2of(1,1,ifine),
     &                    ch2of(1,1,ifine),wratf(1,1,ifine),
     &                    fconvf(1,ifine),fstrtf(1,ifine),
     &                    kcldbf(1,ifine),kcldtf(1,ifine),
     &                    kfrzf(1,ifine),xmdf(1,1,ifine),
     &                    pstarf(1,ifine),ozonef(1,1,ifine),
     &                    h2o2f(1,1,ifine),
     &                    ctlonf(1,ifine),ctlatf(1,ifine),
     &                    cloudf(1,1,ifine),avterrf(1,ifine),
     &                    cncf(1,1,1,ifine),wpositf(1,1,ifine),
     &                    ohconf(1,1,1,ifine),no3conf(1,1,1,ifine),
     &                    ho2conf(1,1,1,ifine),aso2conf(1,1,1,ifine),
     &                    ffnonpr(1,1,ifine),qfarea(1,1,ifine))
	      else
                call rchemf(timfg_ch,ndate,deltf(ifine),idebug,
     &                    nfx(ifine),nfy(ifine),nfz(ifine),nospec,ifine,
     &                    rainf(1,ifine),htf(1,1,ifine),
     &                    presf(1,1,ifine),temprf(1,1,ifine),
     &                    clh2of(1,1,ifine), rnh2of(1,1,ifine),
     &                    ch2of(1,1,ifine),wratf(1,1,ifine),
     &                    fconvf(1,ifine),fstrtf(1,ifine),
     &                    kcldbf(1,ifine),kcldtf(1,ifine),
     &                    kfrzf(1,ifine),xmdf(1,1,ifine),
     &                    pstarf(1,ifine),ozonef(1,1,ifine),
     &                    h2o2f(1,1,ifine),pecconf(1,1,1,ifine),
     &                    ctlonf(1,ifine),ctlatf(1,ifine),
     &                    cloudf(1,1,ifine),avterrf(1,ifine),
     &                    cncf(1,1,1,ifine),wpositf(1,1,ifine),
     &                    ohconf(1,1,1,ifine),no3conf(1,1,1,ifine),
     &                    ho2conf(1,1,1,ifine),aso2conf(1,1,1,ifine),
     &                    ffnonpr(1,1,ifine))
	      endif
              if (idiag .ne. 0 .or. idiagt .ne. 0 ) then
                write(*,'(a)') ' finished rchemf'
		write(*,*) 'timfg_ch,deltf :',timfg_ch,deltf(ifine)
              endif
              dummy=dtime(tarray)
	      rchmtm(ifine)=rchmtm(ifine)+tarray(1)
            endif
c
c-----Perform horizontal advection
c
	    dummy=dtime(tarray)
            call stepxf_04(nfx(ifine),nfy(ifine),nfz(ifine),nospec,
     &                   pstarf(1,ifine),psoldf(1,ifine),
     &                   psnewf(1,ifine),fkh,uf(1,1,ifine),
     &                   vf(1,1,ifine),bcf(1,1,1,1,ifine),
     &                   cncf(1,1,1,ifine),temprf(1,1,ifine),
     &                   ch2of(1,1,ifine),psfcf(1,ifine),
     &                   presf(1,1,ifine),htf(1,1,ifine),
     &                   deltf(ifine)/2.,deltht,ifine)
c
            call stepyf_04(nfx(ifine),nfy(ifine),nfz(ifine),nospec,
     &                   pstarf(1,ifine),psoldf(1,ifine),
     &                   psnewf(1,ifine),fkh,uf(1,1,ifine),
     &                   vf(1,1,ifine),bcf(1,1,1,1,ifine),
     &                   cncf(1,1,1,ifine),temprf(1,1,ifine),
     &                   ch2of(1,1,ifine),psfcf(1,ifine),
     &                   presf(1,1,ifine),htf(1,1,ifine),
     &                   deltf(ifine)/2.,deltht,ifine)
c
            if (idiag .ne. 0) then
              write(*,'(a)') ' finished stepxyf'
              call fmscal(nfx(ifine),nfy(ifine),nfz(ifine),
     &                    delfx(1,ifine),delfy(ifine),sigmaf(1,ifine),
     &                    pstarf(1,ifine),cncf(1,1,1,ifine),ifine)
              write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &               (ftmas(l,ifine),l=1,nospec)
            endif
            dummy=dtime(tarray)
	    stpxtm(ifine)=stpxtm(ifine)+tarray(1)
c
c-----Perform vertical advection
c
            call stepzf(nfx(ifine),nfy(ifine),nfz(ifine),nospec,
     &                  deltf(ifine)/2.,sigdotf(1,1,ifine),
     &                  htf(1,1,ifine),vgf(1,1,1,ifine),
     &                  cncf(1,1,1,ifine),idebug,ifine)
            if (idiag .ne. 0) then
              write(*,'(a)') ' finished stepzf'
              call fmscal(nfx(ifine),nfy(ifine),nfz(ifine),
     &                    delfx(1,ifine),delfy(ifine),sigmaf(1,ifine),
     &                    pstarf(1,ifine),cncf(1,1,1,ifine),ifine)
              write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &               (ftmas(l,ifine),l=1,nospec)
            endif
            dummy=dtime(tarray)
	    stpztm(ifine)=stpztm(ifine)+tarray(1)
c
c-----Perform vertical diffusion
c
            call fvrtdif(nfx(ifine),nfy(ifine),nfz(ifine),nospec,
     &                   deltf(ifine)/2.,ifine,pstarf(1,ifine),
     &                   presf(1,1,ifine),temprf(1,1,ifine),
     &                   ch2of(1,1,ifine),fkv(1,1,ifine),htf(1,1,ifine),
     &                   depvelf(1,1,ifine),cncf(1,1,1,ifine),
     &                   dpositf(1,1,ifine),idebug)
            if (idiag .ne. 0) then
              write(*,'(a)') ' finished clvdff'
              call fmscal(nfx(ifine),nfy(ifine),nfz(ifine),
     &                    delfx(1,ifine),delfy(ifine),sigmaf(1,ifine),
     &                    pstarf(1,ifine),cncf(1,1,1,ifine),ifine)
              write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &               (ftmas(l,ifine),l=1,nospec)
            endif
            dummy=dtime(tarray)
	    vrtdtm(ifine)=vrtdtm(ifine)+tarray(1)
c
c-----Accumulate concentrations for average
c
            if (mavg .eq. 3 .and. 
     &          ndfcom(ifine) .eq. ndftot(ifine)) mfav = 3
            call avergf(mfav,nfx(ifine),nfy(ifine),nfz(ifine),nospec,
     &                  presf(1,1,ifine),temprf(1,1,ifine),
     &                  cncf(1,1,1,ifine),coldf(1,1,ifine),
     &                  avconf(1,1,ifine),avgtmf(ifine),
     &                  deltf(ifine),time,ndate)
  390     continue
          dummy=dtime(tarray)
          tstptm(ifine)=tstptm(ifine)+tarray(1)+verttm(ifine)+
     &           vrtdtm(ifine)+rchmtm(ifine)+stpztm(ifine)+stpxtm(ifine)
c          if ( ifine .gt. 1 ) then
c            elapg(ifine)=elapg(ifine)+tstptm+difftm-elapg(ifine-1)
c          else
            elapg(ifine)=elapg(ifine)+tstptm(ifine)+difftm(ifine)
c          endif
c            write (*,*) 'before end of 400'
  400   continue
c
c-----Refresh concentrations for fine grids with grids nested within them
c
        do 420 ifine=numfin,1,-1
          if (ifgptr(ifine) .gt. 0) then
            if2 = ifgptr(ifine)
            call nstfil(cncf(1,1,1,ifine),cncf(1,1,1,if2),
     &                  dpositf(1,1,ifine),dpositf(1,1,if2),
     &                  wpositf(1,1,ifine),wpositf(1,1,if2),
     &                  pstarf(1,ifine),pstarf(1,if2),
     &                  sigmaf(1,ifine),sigmaf(1,if2),nfx(ifine),
     &                  nfy(ifine),nfz(ifine),nfx(if2),nfy(if2),
     &                  nfz(if2),nospec,ifine,if2)
          endif
  420   continue
c
c-----End of loop over fine grid passes
c
c        write (*,*) 'before end of 450 loop'
  450 continue
c
c-----Ran out of passes before completing fine grid calcs
c
      if (numfin .gt. 0) then
        write(*,*) ' Maximum number of fine grid passes (',nmxpas,
     &             ') has been exceeded.'
        write(*,*) ' Increase nmxpas'
        stop
      endif
c
c-----Fill in coarse grid with fine grid concentrations where they overlap
c
  460 dummy = dtime(tarray)
      do 470 ifine=1,numfin
        tstptmt=tstptmt+tstptm(ifine)
        verttmt=verttmt+verttm(ifine)
        vrtdtmt=vrtdtmt+vrtdtm(ifine)
        stpxtmt=stpxtmt+stpxtm(ifine)
        stpztmt=stpztmt+stpztm(ifine)
        difftmt=difftmt+difftm(ifine)
        rchmtmt=rchmtmt+rchmtm(ifine)
        if (ifgptr(ifine) .eq. 0) then
          call crsfil(cncf(1,1,1,ifine),dpositf(1,1,ifine),
     &                wpositf(1,1,ifine),sigmaf(1,ifine),nfx(ifine),
     &                nfy(ifine),nospec,nfz(ifine),pstarf(1,ifine),
     &                ifine,idebug)
	crsfltmt=crsfltmt+tarray(1)
        dummy=dtime(tarray)
          if (idiag .ne. 0) then
            write(*,'(a)') ' finished crsfil;',
     &                     ' all fine grids are finished'
            call mascal
            write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &                                         (tmas(l),l=1,nospec)
          endif
        endif
  470 continue
c      write (*,*) 'after 470 loop'
c
c-----Write out CPU time summaries for fine grids
c
        ifpout = ifpout - 1
        write(*,*) ' completed fine grids in ',ifpout,' passes.'
	write(*,3302) difftmt,tstptmt,verttmt,stpxtmt,stpztmt,
     &                vrtdtmt,rchmtmt,crsfltmt
	write(66,3302) difftmt,tstptmt,verttmt,stpxtmt,stpztmt,
     &                vrtdtmt,rchmtmt,crsfltmt
 3302   format(' elapsed time for fine grid operations:',/,
     &         ' diffsf               ',f7.2,/,
     &         ' timestep loop        ',f7.2,/,
     &         '   fvrtwd/emfine/fbdfil/htfnew ',f7.2,/,
     &         '   stepxyf                     ',f7.2,/,
     &         '   stepzf                      ',f7.2,/,
     &         '   fvrtdif                     ',f7.2,/,
     &         '   rchemf                      ',f7.2,/,
     &         ' crsfil               ',f7.2)
        write(*,3303) (ifine,elapg(ifine),ifine=1,numfin)
        write(66,3303) (ifine,elapg(ifine),ifine=1,numfin)
 3303   format(' total elapsed for each nested grid:',/,
     &         (5x,i4,5x,f7.2))
c
c      write (*,*) 'stopped at the end of xfine'
c      stop
c        write (*,*) 'end of xfine loop'
      return
      end
